' Import needed namespaces.
' Note that this must occur before the class definition.
Imports System.Xml
Imports System.Xml.Xsl
Imports System.Xml.XPath
Imports System.IO

' A simple XSL transformation class.
Public Class TranslateHTML
    ' This is a function because a value returns.
    Public Function TranslateFiles(ByVal xml_file As String, _
      ByVal xsl_file As String) As String
        Dim xsl_transform As XslTransform
        Dim xpath_document As XPathDocument
        Dim string_writer As New StringWriter()
        Dim xml_text_writer As New XmlTextWriter(string_writer)

        ' Load the XSL file into the XslTransform object.
        xsl_transform = New XslTransform()
        xsl_transform.Load(xsl_file)

        ' Load the XML file into the XPathDocument object.
         xpath_document = New XPathDocument(xml_file)

        ' Transform xpath_document (the XML), sending the results
        ' to the xml_text_writer, which sends its results to
        ' string_writer.
        xml_text_writer.Formatting = Formatting.Indented
        xsl_transform.Transform(xpath_document, Nothing, xml_text_writer)
        xml_text_writer.Flush()

        ' Return the results.
        Return string_writer.ToString()
    End Function
End Class
